/*
 * (C) Copyright 2002
 * Gary Jennejohn, DENX Software Engineering, <gj@denx.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <common.h>

#include <arm940t.h>

#include <asm/arch/symbol.h>
#include <asm/arch/porting.h>
#include <asm/arch/serial.h>
#include <asm/arch/star_uart.h>


void serial_setbrg(bd_t *bd, int baudrate)
{

}


/*
 * Initialise the serial port with the given baudrate. The settings
 * are always 8 data bits, no parity, 1 stop bit, no start bits.
 *
 */
void serial_init(bd_t *bd)
{
    extern void UART_Init(unsigned int baudRate);
    
    UART_Init(bd->bi_baudrate);
}

/*
 * Read a single byte from the serial port. Returns 1 on success, 0
 * otherwise. When the function is succesfull, the character read is
 * written into its argument c.
 */
int serial_getc(void)
{
     char  rx_data;
     
     while (!UART_CHECK_RX_DATA_READY())
     {
     	// wait..........
     }
     
     rx_data = (char)(UART_RBR & 0xFF);
     
     return  rx_data;
}


/*
 * Output a single byte to the serial port.
 */
void serial_putc(const char c)
{
    sys_putchar(c);
	
    /* 
     * If \n, also do \r 
     */
    if(c == '\n')
    {
        serial_putc('\r');
    }
}		


/*
 * Test whether a character is in the RX buffer
 */
int serial_tstc(void)
{
    return (UART_CHECK_RX_DATA_READY());
}

